include "inc/exec/types.inc";
include "inc/utility/tagitem.inc";

struct KeyQuery is
  kq_KeyCode:uword;
  kq_Pressed:word;
;

def LLKB_LSHIFT = 16;
def LLKB_RSHIFT = 17;
def LLKB_CAPSLOCK = 18;
def LLKB_CONTROL = 19;
def LLKB_LALT = 20;
def LLKB_RALT = 21;
def LLKB_LAMIGA = 22;
def LLKB_RAMIGA = 23;

def LLKF_LSHIFT = (1<<LLKB_LSHIFT);
def LLKF_RSHIFT = (1<<LLKB_RSHIFT);
def LLKF_CAPSLOCK = (1<<LLKB_CAPSLOCK);
def LLKF_CONTROL = (1<<LLKB_CONTROL);
def LLKF_LALT = (1<<LLKB_LALT);
def LLKF_RALT = (1<<LLKB_RALT);
def LLKF_LAMIGA = (1<<LLKB_LAMIGA);
def LLKF_RAMIGA = (1<<LLKB_RAMIGA);

def SJA_Dummy = (TAG_USER+$c00100);

def SJA_Type = (SJA_Dummy+1);
def SJA_Reinitialize = (SJA_Dummy+2);

def SJA_TYPE_AUTOSENSE = 0;
def SJA_TYPE_GAMECTLR = 1;
def SJA_TYPE_MOUSE = 2;
def SJA_TYPE_JOYSTK = 3;

def JP_TYPE_NOTAVAIL = (0<<28);
def JP_TYPE_GAMECTLR = (1<<28);
def JP_TYPE_MOUSE = (2<<28);
def JP_TYPE_JOYSTK = (3<<28);
def JP_TYPE_UNKNOWN = (4<<28);
def JP_TYPE_MASK = (15<<28);

def JPB_BUTTON_BLUE = 23;
def JPB_BUTTON_RED = 22;
def JPB_BUTTON_YELLOW = 21;
def JPB_BUTTON_GREEN = 20;
def JPB_BUTTON_FORWARD = 19;
def JPB_BUTTON_REVERSE = 18;
def JPB_BUTTON_PLAY = 17;
def JPF_BUTTON_BLUE = (1<<JPB_BUTTON_BLUE);
def JPF_BUTTON_RED = (1<<JPB_BUTTON_RED);
def JPF_BUTTON_YELLOW = (1<<JPB_BUTTON_YELLOW);
def JPF_BUTTON_GREEN = (1<<JPB_BUTTON_GREEN);
def JPF_BUTTON_FORWARD = (1<<JPB_BUTTON_FORWARD);
def JPF_BUTTON_REVERSE = (1<<JPB_BUTTON_REVERSE);
def JPF_BUTTON_PLAY = (1<<JPB_BUTTON_PLAY);
def JP_BUTTON_MASK = (JPF_BUTTON_BLUE|JPF_BUTTON_RED|JPF_BUTTON_YELLOW|JPF_BUTTON_GREEN|JPF_BUTTON_FORWARD|JPF_BUTTON_REVERSE|JPF_BUTTON_PLAY);

def JPB_JOY_UP = 3;
def JPB_JOY_DOWN = 2;
def JPB_JOY_LEFT = 1;
def JPB_JOY_RIGHT = 0;
def JPF_JOY_UP = (1<<JPB_JOY_UP);
def JPF_JOY_DOWN = (1<<JPB_JOY_DOWN);
def JPF_JOY_LEFT = (1<<JPB_JOY_LEFT);
def JPF_JOY_RIGHT = (1<<JPB_JOY_RIGHT);
def JP_DIRECTION_MASK = (JPF_JOY_UP|JPF_JOY_DOWN|JPF_JOY_LEFT|JPF_JOY_RIGHT);

def JP_MHORZ_MASK = (255<<0);
def JP_MVERT_MASK = (255<<8);
def JP_MOUSE_MASK = (JP_MHORZ_MASK|JP_MVERT_MASK);

def SCON_Dummy = (TAG_USER+$00c00000);
def SCON_TakeOverSys = (SCON_Dummy+0);
def SCON_KillReq = (SCON_Dummy+1);
def SCON_CDReboot = (SCON_Dummy+2);
def SCON_StopInput = (SCON_Dummy+3);
def SCON_AddCreateKeys = (SCON_Dummy+4);
def SCON_RemCreateKeys = (SCON_Dummy+5);

def CDReboot_On = 1;
def CDReboot_Off = 0;
def CDReboot_Default = 2;

def RAWKEY_PORT0_BUTTON_BLUE = $72;
def RAWKEY_PORT0_BUTTON_RED = $78;
def RAWKEY_PORT0_BUTTON_YELLOW = $77;
def RAWKEY_PORT0_BUTTON_GREEN = $76;
def RAWKEY_PORT0_BUTTON_FORWARD = $75;
def RAWKEY_PORT0_BUTTON_REVERSE = $74;
def RAWKEY_PORT0_BUTTON_PLAY = $73;
def RAWKEY_PORT0_JOY_UP = $79;
def RAWKEY_PORT0_JOY_DOWN = $7a;
def RAWKEY_PORT0_JOY_LEFT = $7c;
def RAWKEY_PORT0_JOY_RIGHT = $7b;

def RAWKEY_PORT1_BUTTON_BLUE = $172;
def RAWKEY_PORT1_BUTTON_RED = $178;
def RAWKEY_PORT1_BUTTON_YELLOW = $177;
def RAWKEY_PORT1_BUTTON_GREEN = $176;
def RAWKEY_PORT1_BUTTON_FORWARD = $175;
def RAWKEY_PORT1_BUTTON_REVERSE = $174;
def RAWKEY_PORT1_BUTTON_PLAY = $173;
def RAWKEY_PORT1_JOY_UP = $179;
def RAWKEY_PORT1_JOY_DOWN = $17a;
def RAWKEY_PORT1_JOY_LEFT = $17c;
def RAWKEY_PORT1_JOY_RIGHT = $17b;

def RAWKEY_PORT2_BUTTON_BLUE = $272;
def RAWKEY_PORT2_BUTTON_RED = $278;
def RAWKEY_PORT2_BUTTON_YELLOW = $277;
def RAWKEY_PORT2_BUTTON_GREEN = $276;
def RAWKEY_PORT2_BUTTON_FORWARD = $275;
def RAWKEY_PORT2_BUTTON_REVERSE = $274;
def RAWKEY_PORT2_BUTTON_PLAY = $273;
def RAWKEY_PORT2_JOY_UP = $279;
def RAWKEY_PORT2_JOY_DOWN = $27a;
def RAWKEY_PORT2_JOY_LEFT = $27c;
def RAWKEY_PORT2_JOY_RIGHT = $27b;

def RAWKEY_PORT3_BUTTON_BLUE = $372;
def RAWKEY_PORT3_BUTTON_RED = $378;
def RAWKEY_PORT3_BUTTON_YELLOW = $377;
def RAWKEY_PORT3_BUTTON_GREEN = $376;
def RAWKEY_PORT3_BUTTON_FORWARD = $375;
def RAWKEY_PORT3_BUTTON_REVERSE = $374;
def RAWKEY_PORT3_BUTTON_PLAY = $373;
def RAWKEY_PORT3_JOY_UP = $379;
def RAWKEY_PORT3_JOY_DOWN = $37a;
def RAWKEY_PORT3_JOY_LEFT = $37c;
def RAWKEY_PORT3_JOY_RIGHT = $37b;

def LANG_UNKNOWN = 0;
def LANG_AMERICAN = 1;
def LANG_ENGLISH = 2;
def LANG_GERMAN = 3;
def LANG_FRENCH = 4;
def LANG_SPANISH = 5;
def LANG_ITALIAN = 6;
def LANG_PORTUGUESE = 7;
def LANG_DANISH = 8;
def LANG_DUTCH = 9;
def LANG_NORWEGIAN = 10;
def LANG_FINNISH = 11;
def LANG_SWEDISH = 12;
def LANG_JAPANESE = 13;
def LANG_CHINESE = 14;
def LANG_ARABIC = 15;
def LANG_GREEK = 16;
def LANG_HEBREW = 17;
def LANG_KOREAN = 18;

